# Fetch 1.1 changelog

- If `w3m` or `imagemagick` aren't installed we gracefully fallback to ascii mode.
- Automatically find the `w3mimgdisplay` path and fallback to ascii mode if not found.
- Fix padding escape codes on BSD systems.
- Swap escape codes from `\e` to `\033` for consistency.
- We only move the cursor to the bottom of the terminal in w3m/iterm2 rendering modes.
- Cursor position is now dynamic based on the height of the ascii and info text.
- If images and ascii are off, don't clear the terminal
- The script now exits correctly instead of always exiting with status code `1`
- If the script exits for any reason, unhide the cursor.
- Removed duplicate blocks inside `getcpu` and `getmemory`.
- Removed `--colors` as it was apparently broken from day 1.

### Config file

- Fetch now has a config file that you can share with people and keep between<br \>
script versions!
- Added `--config` and `$config_file` to specify a custom config location.
- Added `--config off`, `--config none` and `$config` to enable / disable config files<br \>
at launch or in script.


### Makefile

- Fetch now has a make file due to the increasing number of files,<br \>
this allows the script to be easily installed and uninstalled on<br \>
systems it isn't packaged for yet!

**NOTE:** The script will still work just fine on its own, you'll just be missing<br \>
the distro ascii art and the automatic config creation.


### Packages

- Fetch now has a Gentoo/Funtoo e-build courtesy of @z1lt0id


### Info

- Added `--disable` which allows you to stop an info line from appearing at launch.<br \>

```sh
# Stop cpu, gpu, disk and shell functions from being called
fetch --disable cpu gpu disk shell
```

**Kernel:**

- Added `--kernel_shorthand` and `$kernel_shorthand` to print less or more kernel info

**Distro:**

- Added support for showing OS architecture. eg `Arch Linux x86_64`, `Windows 7 Ultimate 64-bit`
    - You can toggle this using `--os_arch` and `$os_arch`.
- Mac OS X: Added support for showing Max OS X build version.
    - You can toggle it using `--osx_buildversion` and `$osx_buildversion`.
- Windows: Added support for showing Windows edition. eg. `Windows 7 Ultimate`

**Window Manager:**

- Added support for `$XINITRC`

**Shell:**

- Added `--shell_version` and `$shell_version` to hide/show your shell's version.
- Added `--shell_path` and `$shell_path` to hide/show the path to your shell

**GTK:**

- Fix incorrect GTK3 theme being displayed

**CPU:**

- `cpu_shorthand`: New substitutions

**GPU:**

- Linux: Count the number of identical GPUs. eg. `Nvidia Geforce GTX 970 x 2`

**Memory:**

- Mac OS X: Added wired memory to memory usage.

**Birthday:**

- Added `birthday` which prints the age of your OS install.
- Added `--birthday_shorthand` and `$birthday_shorthand` to shorten/lengthen<br \>
the output of birthday.
- Added `--birthday_time` and `$birthday_time` to show/hide the time in the output.

**Battery**

- Added `battery` which prints the battery usage percentage for each battery<br \>
in your system.

- Added `battery_num` which allows you to choose which battery to display, <br \>
it also takes the value `all` which will print all batteries line by line.
- Added `battery_shorthand` which when set to `on` prints each battery on the<br \>
same line like so:

```sh
# battery_shorthand="on"
Battery: 10%, 5%, 67%

# battery_shorthand="off"
Battery0: 10%
Battery1: 5%
Battery2: 67%

# If there's only a single battery in the system
# we ommit the numbered title.
Battery: 10%
```

- **NOTE:** This currently doesn't support BSD systems as we have no one to help us test
    - See **[Issue #46](https://github.com/dylanaraps/fetch/issues/46)**


### Image

- Rename `--shuffledir` and `$shuffledir` to `shuffle_dir`.
- Rename `--imgtempdir` and `$imgtempdir` to `thumbnail_dir`
- Default thumbnail directory is now `$HOME/.cache/thumbnails/fetch`
 - Thanks @tudurom
- Added support for ascii art inside of text files.
- If `--image` and `--ascii` are left empty we fallback to ascii distro mode.

```sh
fetch --ascii "path/to/ascii" --ascii_color 2

```

- Added "screenfetch mode" which will display your distro's ascii art<br\>
  next to the info.<br \>
  See: http://github.com/dylanaraps/fetch#how-do-i-enable-screenfetch-mode
- Added `--ascii_distro` to choose which distro's ascii logo to display.
